
#include "amici/symbolic_functions.h"
#include "amici/defines.h" //realtype definition
typedef amici::realtype realtype;
#include <cmath> 

using namespace amici;

void Jv_model_jakstat_adjoint_o2(realtype *Jv, const realtype t, const realtype *x, const realtype *p, const realtype *k, const realtype *h, const realtype *v, const realtype *w, const realtype *dwdx) {
  Jv[0] = k[1]*p[3]*w[2]*v[8]-k[0]*p[0]*v[0]*w[0]*w[2];
  Jv[1] = p[0]*v[0]*w[0]-p[1]*v[1]*dwdx[0]*2.0;
  Jv[2] = -p[2]*v[2]+p[1]*v[1]*dwdx[0];
  Jv[3] = k[0]*p[2]*v[2]*w[3]-k[1]*p[3]*v[3]*w[3];
  Jv[4] = -p[3]*v[4]+p[3]*v[3]*dwdx[1];
  Jv[5] = p[3]*v[4]-p[3]*v[5];
  Jv[6] = p[3]*v[5]-p[3]*v[6];
  Jv[7] = p[3]*v[6]-p[3]*v[7];
  Jv[8] = p[3]*v[7]-p[3]*v[8];
  Jv[9] = -v[0]*w[0]-p[0]*w[0]*v[9]+k[1]*p[3]*w[2]*v[17];
  Jv[10] = v[0]*w[0]+p[0]*w[0]*v[9]-p[1]*v[1]*x[10]*4.0-p[1]*x[1]*v[10]*4.0;
  Jv[11] = -p[2]*v[11]+p[1]*v[1]*x[10]*2.0+p[1]*x[1]*v[10]*2.0;
  Jv[12] = -p[3]*v[12]+k[0]*p[2]*w[3]*v[11];
  Jv[13] = p[3]*v[12]*2.0-p[3]*v[13];
  Jv[14] = p[3]*v[13]-p[3]*v[14];
  Jv[15] = p[3]*v[14]-p[3]*v[15];
  Jv[16] = p[3]*v[15]-p[3]*v[16];
  Jv[17] = p[3]*v[16]-p[3]*v[17];
  Jv[18] = -p[0]*w[0]*v[18]+k[1]*p[3]*w[2]*v[26];
  Jv[19] = -v[1]*(dwdx[0]*2.0+p[1]*x[19]*4.0)+p[0]*w[0]*v[18]-p[1]*x[1]*v[19]*4.0;
  Jv[20] = -p[2]*v[20]+v[1]*(dwdx[0]+p[1]*x[19]*2.0)+p[1]*x[1]*v[19]*2.0;
  Jv[21] = -p[3]*v[21]+k[0]*p[2]*w[3]*v[20];
  Jv[22] = p[3]*v[21]*2.0-p[3]*v[22];
  Jv[23] = p[3]*v[22]-p[3]*v[23];
  Jv[24] = p[3]*v[23]-p[3]*v[24];
  Jv[25] = p[3]*v[24]-p[3]*v[25];
  Jv[26] = p[3]*v[25]-p[3]*v[26];
  Jv[27] = -p[0]*w[0]*v[27]+k[1]*p[3]*w[2]*v[35];
  Jv[28] = p[0]*w[0]*v[27]-p[1]*v[1]*x[28]*4.0-p[1]*x[1]*v[28]*4.0;
  Jv[29] = -v[2]-p[2]*v[29]+p[1]*v[1]*x[28]*2.0+p[1]*x[1]*v[28]*2.0;
  Jv[30] = -p[3]*v[30]+k[0]*v[2]*w[3]+k[0]*p[2]*w[3]*v[29];
  Jv[31] = p[3]*v[30]*2.0-p[3]*v[31];
  Jv[32] = p[3]*v[31]-p[3]*v[32];
  Jv[33] = p[3]*v[32]-p[3]*v[33];
  Jv[34] = p[3]*v[33]-p[3]*v[34];
  Jv[35] = p[3]*v[34]-p[3]*v[35];
  Jv[36] = k[1]*w[2]*v[8]-p[0]*w[0]*v[36]+k[1]*p[3]*w[2]*v[44];
  Jv[37] = p[0]*w[0]*v[36]-p[1]*v[1]*x[37]*4.0-p[1]*x[1]*v[37]*4.0;
  Jv[38] = -p[2]*v[38]+p[1]*v[1]*x[37]*2.0+p[1]*x[1]*v[37]*2.0;
  Jv[39] = -v[3]-p[3]*v[39]+k[0]*p[2]*w[3]*v[38];
  Jv[40] = -v[4]+p[3]*v[39]*2.0-p[3]*v[40]+v[3]*dwdx[1];
  Jv[41] = v[4]-v[5]+p[3]*v[40]-p[3]*v[41];
  Jv[42] = v[5]-v[6]+p[3]*v[41]-p[3]*v[42];
  Jv[43] = v[6]-v[7]+p[3]*v[42]-p[3]*v[43];
  Jv[44] = v[7]-v[8]+p[3]*v[43]-p[3]*v[44];
  Jv[45] = -p[0]*w[0]*v[45]+k[1]*p[3]*w[2]*v[53];
  Jv[46] = p[0]*w[0]*v[45]-p[1]*v[1]*x[46]*4.0-p[1]*x[1]*v[46]*4.0;
  Jv[47] = -p[2]*v[47]+p[1]*v[1]*x[46]*2.0+p[1]*x[1]*v[46]*2.0;
  Jv[48] = -p[3]*v[48]+k[0]*p[2]*w[3]*v[47];
  Jv[49] = p[3]*v[48]*2.0-p[3]*v[49];
  Jv[50] = p[3]*v[49]-p[3]*v[50];
  Jv[51] = p[3]*v[50]-p[3]*v[51];
  Jv[52] = p[3]*v[51]-p[3]*v[52];
  Jv[53] = p[3]*v[52]-p[3]*v[53];
  Jv[54] = -p[0]*v[0]*w[5]-p[0]*w[0]*v[54]+k[1]*p[3]*w[2]*v[62];
  Jv[55] = p[0]*v[0]*w[5]+p[0]*w[0]*v[54]-p[1]*v[1]*x[55]*4.0-p[1]*x[1]*v[55]*4.0;
  Jv[56] = -p[2]*v[56]+p[1]*v[1]*x[55]*2.0+p[1]*x[1]*v[55]*2.0;
  Jv[57] = -p[3]*v[57]+k[0]*p[2]*w[3]*v[56];
  Jv[58] = p[3]*v[57]*2.0-p[3]*v[58];
  Jv[59] = p[3]*v[58]-p[3]*v[59];
  Jv[60] = p[3]*v[59]-p[3]*v[60];
  Jv[61] = p[3]*v[60]-p[3]*v[61];
  Jv[62] = p[3]*v[61]-p[3]*v[62];
  Jv[63] = -p[0]*v[0]*w[6]-p[0]*w[0]*v[63]+k[1]*p[3]*w[2]*v[71];
  Jv[64] = p[0]*v[0]*w[6]+p[0]*w[0]*v[63]-p[1]*v[1]*x[64]*4.0-p[1]*x[1]*v[64]*4.0;
  Jv[65] = -p[2]*v[65]+p[1]*v[1]*x[64]*2.0+p[1]*x[1]*v[64]*2.0;
  Jv[66] = -p[3]*v[66]+k[0]*p[2]*w[3]*v[65];
  Jv[67] = p[3]*v[66]*2.0-p[3]*v[67];
  Jv[68] = p[3]*v[67]-p[3]*v[68];
  Jv[69] = p[3]*v[68]-p[3]*v[69];
  Jv[70] = p[3]*v[69]-p[3]*v[70];
  Jv[71] = p[3]*v[70]-p[3]*v[71];
  Jv[72] = -p[0]*v[0]*w[7]-p[0]*w[0]*v[72]+k[1]*p[3]*w[2]*v[80];
  Jv[73] = p[0]*v[0]*w[7]+p[0]*w[0]*v[72]-p[1]*v[1]*x[73]*4.0-p[1]*x[1]*v[73]*4.0;
  Jv[74] = -p[2]*v[74]+p[1]*v[1]*x[73]*2.0+p[1]*x[1]*v[73]*2.0;
  Jv[75] = -p[3]*v[75]+k[0]*p[2]*w[3]*v[74];
  Jv[76] = p[3]*v[75]*2.0-p[3]*v[76];
  Jv[77] = p[3]*v[76]-p[3]*v[77];
  Jv[78] = p[3]*v[77]-p[3]*v[78];
  Jv[79] = p[3]*v[78]-p[3]*v[79];
  Jv[80] = p[3]*v[79]-p[3]*v[80];
  Jv[81] = -p[0]*v[0]*w[8]-p[0]*w[0]*v[81]+k[1]*p[3]*w[2]*v[89];
  Jv[82] = p[0]*v[0]*w[8]+p[0]*w[0]*v[81]-p[1]*v[1]*x[82]*4.0-p[1]*x[1]*v[82]*4.0;
  Jv[83] = -p[2]*v[83]+p[1]*v[1]*x[82]*2.0+p[1]*x[1]*v[82]*2.0;
  Jv[84] = -p[3]*v[84]+k[0]*p[2]*w[3]*v[83];
  Jv[85] = p[3]*v[84]*2.0-p[3]*v[85];
  Jv[86] = p[3]*v[85]-p[3]*v[86];
  Jv[87] = p[3]*v[86]-p[3]*v[87];
  Jv[88] = p[3]*v[87]-p[3]*v[88];
  Jv[89] = p[3]*v[88]-p[3]*v[89];
  Jv[90] = -p[0]*v[0]*w[9]-p[0]*w[0]*v[90]+k[1]*p[3]*w[2]*v[98];
  Jv[91] = p[0]*v[0]*w[9]+p[0]*w[0]*v[90]-p[1]*v[1]*x[91]*4.0-p[1]*x[1]*v[91]*4.0;
  Jv[92] = -p[2]*v[92]+p[1]*v[1]*x[91]*2.0+p[1]*x[1]*v[91]*2.0;
  Jv[93] = -p[3]*v[93]+k[0]*p[2]*w[3]*v[92];
  Jv[94] = p[3]*v[93]*2.0-p[3]*v[94];
  Jv[95] = p[3]*v[94]-p[3]*v[95];
  Jv[96] = p[3]*v[95]-p[3]*v[96];
  Jv[97] = p[3]*v[96]-p[3]*v[97];
  Jv[98] = p[3]*v[97]-p[3]*v[98];
  Jv[99] = -p[0]*w[0]*v[99]+k[1]*p[3]*w[2]*v[107];
  Jv[100] = p[0]*w[0]*v[99]-p[1]*v[1]*x[100]*4.0-p[1]*x[1]*v[100]*4.0;
  Jv[101] = -p[2]*v[101]+p[1]*v[1]*x[100]*2.0+p[1]*x[1]*v[100]*2.0;
  Jv[102] = -p[3]*v[102]+k[0]*p[2]*w[3]*v[101];
  Jv[103] = p[3]*v[102]*2.0-p[3]*v[103];
  Jv[104] = p[3]*v[103]-p[3]*v[104];
  Jv[105] = p[3]*v[104]-p[3]*v[105];
  Jv[106] = p[3]*v[105]-p[3]*v[106];
  Jv[107] = p[3]*v[106]-p[3]*v[107];
  Jv[108] = -p[0]*w[0]*v[108]+k[1]*p[3]*w[2]*v[116];
  Jv[109] = p[0]*w[0]*v[108]-p[1]*v[1]*x[109]*4.0-p[1]*x[1]*v[109]*4.0;
  Jv[110] = -p[2]*v[110]+p[1]*v[1]*x[109]*2.0+p[1]*x[1]*v[109]*2.0;
  Jv[111] = -p[3]*v[111]+k[0]*p[2]*w[3]*v[110];
  Jv[112] = p[3]*v[111]*2.0-p[3]*v[112];
  Jv[113] = p[3]*v[112]-p[3]*v[113];
  Jv[114] = p[3]*v[113]-p[3]*v[114];
  Jv[115] = p[3]*v[114]-p[3]*v[115];
  Jv[116] = p[3]*v[115]-p[3]*v[116];
  Jv[117] = -p[0]*w[0]*v[117]+k[1]*p[3]*w[2]*v[125];
  Jv[118] = p[0]*w[0]*v[117]-p[1]*v[1]*x[118]*4.0-p[1]*x[1]*v[118]*4.0;
  Jv[119] = -p[2]*v[119]+p[1]*v[1]*x[118]*2.0+p[1]*x[1]*v[118]*2.0;
  Jv[120] = -p[3]*v[120]+k[0]*p[2]*w[3]*v[119];
  Jv[121] = p[3]*v[120]*2.0-p[3]*v[121];
  Jv[122] = p[3]*v[121]-p[3]*v[122];
  Jv[123] = p[3]*v[122]-p[3]*v[123];
  Jv[124] = p[3]*v[123]-p[3]*v[124];
  Jv[125] = p[3]*v[124]-p[3]*v[125];
  Jv[126] = -p[0]*w[0]*v[126]+k[1]*p[3]*w[2]*v[134];
  Jv[127] = p[0]*w[0]*v[126]-p[1]*v[1]*x[127]*4.0-p[1]*x[1]*v[127]*4.0;
  Jv[128] = -p[2]*v[128]+p[1]*v[1]*x[127]*2.0+p[1]*x[1]*v[127]*2.0;
  Jv[129] = -p[3]*v[129]+k[0]*p[2]*w[3]*v[128];
  Jv[130] = p[3]*v[129]*2.0-p[3]*v[130];
  Jv[131] = p[3]*v[130]-p[3]*v[131];
  Jv[132] = p[3]*v[131]-p[3]*v[132];
  Jv[133] = p[3]*v[132]-p[3]*v[133];
  Jv[134] = p[3]*v[133]-p[3]*v[134];
  Jv[135] = -p[0]*w[0]*v[135]+k[1]*p[3]*w[2]*v[143];
  Jv[136] = p[0]*w[0]*v[135]-p[1]*v[1]*x[136]*4.0-p[1]*x[1]*v[136]*4.0;
  Jv[137] = -p[2]*v[137]+p[1]*v[1]*x[136]*2.0+p[1]*x[1]*v[136]*2.0;
  Jv[138] = -p[3]*v[138]+k[0]*p[2]*w[3]*v[137];
  Jv[139] = p[3]*v[138]*2.0-p[3]*v[139];
  Jv[140] = p[3]*v[139]-p[3]*v[140];
  Jv[141] = p[3]*v[140]-p[3]*v[141];
  Jv[142] = p[3]*v[141]-p[3]*v[142];
  Jv[143] = p[3]*v[142]-p[3]*v[143];
  Jv[144] = -p[0]*w[0]*v[144]+k[1]*p[3]*w[2]*v[152];
  Jv[145] = p[0]*w[0]*v[144]-p[1]*v[1]*x[145]*4.0-p[1]*x[1]*v[145]*4.0;
  Jv[146] = -p[2]*v[146]+p[1]*v[1]*x[145]*2.0+p[1]*x[1]*v[145]*2.0;
  Jv[147] = -p[3]*v[147]+k[0]*p[2]*w[3]*v[146];
  Jv[148] = p[3]*v[147]*2.0-p[3]*v[148];
  Jv[149] = p[3]*v[148]-p[3]*v[149];
  Jv[150] = p[3]*v[149]-p[3]*v[150];
  Jv[151] = p[3]*v[150]-p[3]*v[151];
  Jv[152] = p[3]*v[151]-p[3]*v[152];
  Jv[153] = -p[0]*w[0]*v[153]+k[1]*p[3]*w[2]*v[161];
  Jv[154] = p[0]*w[0]*v[153]-p[1]*v[1]*x[154]*4.0-p[1]*x[1]*v[154]*4.0;
  Jv[155] = -p[2]*v[155]+p[1]*v[1]*x[154]*2.0+p[1]*x[1]*v[154]*2.0;
  Jv[156] = -p[3]*v[156]+k[0]*p[2]*w[3]*v[155];
  Jv[157] = p[3]*v[156]*2.0-p[3]*v[157];
  Jv[158] = p[3]*v[157]-p[3]*v[158];
  Jv[159] = p[3]*v[158]-p[3]*v[159];
  Jv[160] = p[3]*v[159]-p[3]*v[160];
  Jv[161] = p[3]*v[160]-p[3]*v[161];
}

