
#include "amici/symbolic_functions.h"
#include "amici/defines.h" //realtype definition
typedef amici::realtype realtype;
#include <cmath> 

using namespace amici;

void JvB_model_jakstat_adjoint_o2(realtype *JvB, const realtype t, const realtype *x, const realtype *p, const realtype *k, const realtype *h, const realtype *xB, const realtype *vB, const realtype *w, const realtype *dwdx) {
  JvB[0] = -p[0]*w[0]*vB[1]+k[0]*p[0]*w[0]*w[2]*vB[0];
  JvB[1] = p[1]*vB[1]*dwdx[0]*2.0-p[1]*vB[2]*dwdx[0];
  JvB[2] = p[2]*vB[2]-k[0]*p[2]*w[3]*vB[3];
  JvB[3] = -p[3]*vB[4]*dwdx[1]+k[1]*p[3]*w[3]*vB[3];
  JvB[4] = p[3]*vB[4]-p[3]*vB[5];
  JvB[5] = p[3]*vB[5]-p[3]*vB[6];
  JvB[6] = p[3]*vB[6]-p[3]*vB[7];
  JvB[7] = p[3]*vB[7]-p[3]*vB[8];
  JvB[8] = p[3]*vB[8]-k[1]*p[3]*w[2]*vB[0];
  JvB[9] = w[0]*vB[0]-w[0]*vB[1]+p[0]*w[0]*vB[9]-p[0]*w[0]*vB[10];
  JvB[10] = p[1]*x[1]*vB[10]*4.0+p[1]*x[10]*vB[1]*4.0-p[1]*x[1]*vB[11]*2.0-p[1]*x[10]*vB[2]*2.0;
  JvB[11] = p[2]*vB[11]-k[0]*p[2]*w[3]*vB[12];
  JvB[12] = p[3]*vB[12]-p[3]*vB[13]*2.0;
  JvB[13] = p[3]*vB[13]-p[3]*vB[14];
  JvB[14] = p[3]*vB[14]-p[3]*vB[15];
  JvB[15] = p[3]*vB[15]-p[3]*vB[16];
  JvB[16] = p[3]*vB[16]-p[3]*vB[17];
  JvB[17] = p[3]*vB[17]-k[1]*p[3]*w[2]*vB[9];
  JvB[18] = p[0]*w[0]*vB[18]-p[0]*w[0]*vB[19];
  JvB[19] = vB[1]*(dwdx[0]*2.0+p[1]*x[19]*4.0)-vB[2]*(dwdx[0]+p[1]*x[19]*2.0)+p[1]*x[1]*vB[19]*4.0-p[1]*x[1]*vB[20]*2.0;
  JvB[20] = p[2]*vB[20]-k[0]*p[2]*w[3]*vB[21];
  JvB[21] = p[3]*vB[21]-p[3]*vB[22]*2.0;
  JvB[22] = p[3]*vB[22]-p[3]*vB[23];
  JvB[23] = p[3]*vB[23]-p[3]*vB[24];
  JvB[24] = p[3]*vB[24]-p[3]*vB[25];
  JvB[25] = p[3]*vB[25]-p[3]*vB[26];
  JvB[26] = p[3]*vB[26]-k[1]*p[3]*w[2]*vB[18];
  JvB[27] = p[0]*w[0]*vB[27]-p[0]*w[0]*vB[28];
  JvB[28] = p[1]*x[1]*vB[28]*4.0+p[1]*x[28]*vB[1]*4.0-p[1]*x[1]*vB[29]*2.0-p[1]*x[28]*vB[2]*2.0;
  JvB[29] = vB[2]+p[2]*vB[29]-k[0]*w[3]*vB[3]-k[0]*p[2]*w[3]*vB[30];
  JvB[30] = p[3]*vB[30]-p[3]*vB[31]*2.0;
  JvB[31] = p[3]*vB[31]-p[3]*vB[32];
  JvB[32] = p[3]*vB[32]-p[3]*vB[33];
  JvB[33] = p[3]*vB[33]-p[3]*vB[34];
  JvB[34] = p[3]*vB[34]-p[3]*vB[35];
  JvB[35] = p[3]*vB[35]-k[1]*p[3]*w[2]*vB[27];
  JvB[36] = p[0]*w[0]*vB[36]-p[0]*w[0]*vB[37];
  JvB[37] = p[1]*x[1]*vB[37]*4.0+p[1]*x[37]*vB[1]*4.0-p[1]*x[1]*vB[38]*2.0-p[1]*x[37]*vB[2]*2.0;
  JvB[38] = p[2]*vB[38]-k[0]*p[2]*w[3]*vB[39];
  JvB[39] = vB[3]+p[3]*vB[39]-p[3]*vB[40]*2.0-vB[4]*dwdx[1];
  JvB[40] = vB[4]-vB[5]+p[3]*vB[40]-p[3]*vB[41];
  JvB[41] = vB[5]-vB[6]+p[3]*vB[41]-p[3]*vB[42];
  JvB[42] = vB[6]-vB[7]+p[3]*vB[42]-p[3]*vB[43];
  JvB[43] = vB[7]-vB[8]+p[3]*vB[43]-p[3]*vB[44];
  JvB[44] = vB[8]+p[3]*vB[44]-k[1]*w[2]*vB[0]-k[1]*p[3]*w[2]*vB[36];
  JvB[45] = p[0]*w[0]*vB[45]-p[0]*w[0]*vB[46];
  JvB[46] = p[1]*x[1]*vB[46]*4.0+p[1]*x[46]*vB[1]*4.0-p[1]*x[1]*vB[47]*2.0-p[1]*x[46]*vB[2]*2.0;
  JvB[47] = p[2]*vB[47]-k[0]*p[2]*w[3]*vB[48];
  JvB[48] = p[3]*vB[48]-p[3]*vB[49]*2.0;
  JvB[49] = p[3]*vB[49]-p[3]*vB[50];
  JvB[50] = p[3]*vB[50]-p[3]*vB[51];
  JvB[51] = p[3]*vB[51]-p[3]*vB[52];
  JvB[52] = p[3]*vB[52]-p[3]*vB[53];
  JvB[53] = p[3]*vB[53]-k[1]*p[3]*w[2]*vB[45];
  JvB[54] = p[0]*w[5]*vB[0]-p[0]*w[5]*vB[1]+p[0]*w[0]*vB[54]-p[0]*w[0]*vB[55];
  JvB[55] = p[1]*x[1]*vB[55]*4.0+p[1]*x[55]*vB[1]*4.0-p[1]*x[1]*vB[56]*2.0-p[1]*x[55]*vB[2]*2.0;
  JvB[56] = p[2]*vB[56]-k[0]*p[2]*w[3]*vB[57];
  JvB[57] = p[3]*vB[57]-p[3]*vB[58]*2.0;
  JvB[58] = p[3]*vB[58]-p[3]*vB[59];
  JvB[59] = p[3]*vB[59]-p[3]*vB[60];
  JvB[60] = p[3]*vB[60]-p[3]*vB[61];
  JvB[61] = p[3]*vB[61]-p[3]*vB[62];
  JvB[62] = p[3]*vB[62]-k[1]*p[3]*w[2]*vB[54];
  JvB[63] = p[0]*w[6]*vB[0]-p[0]*w[6]*vB[1]+p[0]*w[0]*vB[63]-p[0]*w[0]*vB[64];
  JvB[64] = p[1]*x[1]*vB[64]*4.0+p[1]*x[64]*vB[1]*4.0-p[1]*x[1]*vB[65]*2.0-p[1]*x[64]*vB[2]*2.0;
  JvB[65] = p[2]*vB[65]-k[0]*p[2]*w[3]*vB[66];
  JvB[66] = p[3]*vB[66]-p[3]*vB[67]*2.0;
  JvB[67] = p[3]*vB[67]-p[3]*vB[68];
  JvB[68] = p[3]*vB[68]-p[3]*vB[69];
  JvB[69] = p[3]*vB[69]-p[3]*vB[70];
  JvB[70] = p[3]*vB[70]-p[3]*vB[71];
  JvB[71] = p[3]*vB[71]-k[1]*p[3]*w[2]*vB[63];
  JvB[72] = p[0]*w[7]*vB[0]-p[0]*w[7]*vB[1]+p[0]*w[0]*vB[72]-p[0]*w[0]*vB[73];
  JvB[73] = p[1]*x[1]*vB[73]*4.0+p[1]*vB[1]*x[73]*4.0-p[1]*x[1]*vB[74]*2.0-p[1]*vB[2]*x[73]*2.0;
  JvB[74] = p[2]*vB[74]-k[0]*p[2]*w[3]*vB[75];
  JvB[75] = p[3]*vB[75]-p[3]*vB[76]*2.0;
  JvB[76] = p[3]*vB[76]-p[3]*vB[77];
  JvB[77] = p[3]*vB[77]-p[3]*vB[78];
  JvB[78] = p[3]*vB[78]-p[3]*vB[79];
  JvB[79] = p[3]*vB[79]-p[3]*vB[80];
  JvB[80] = p[3]*vB[80]-k[1]*p[3]*w[2]*vB[72];
  JvB[81] = p[0]*w[8]*vB[0]-p[0]*w[8]*vB[1]+p[0]*w[0]*vB[81]-p[0]*w[0]*vB[82];
  JvB[82] = p[1]*x[1]*vB[82]*4.0+p[1]*vB[1]*x[82]*4.0-p[1]*x[1]*vB[83]*2.0-p[1]*vB[2]*x[82]*2.0;
  JvB[83] = p[2]*vB[83]-k[0]*p[2]*w[3]*vB[84];
  JvB[84] = p[3]*vB[84]-p[3]*vB[85]*2.0;
  JvB[85] = p[3]*vB[85]-p[3]*vB[86];
  JvB[86] = p[3]*vB[86]-p[3]*vB[87];
  JvB[87] = p[3]*vB[87]-p[3]*vB[88];
  JvB[88] = p[3]*vB[88]-p[3]*vB[89];
  JvB[89] = p[3]*vB[89]-k[1]*p[3]*w[2]*vB[81];
  JvB[90] = p[0]*w[9]*vB[0]-p[0]*w[9]*vB[1]+p[0]*w[0]*vB[90]-p[0]*w[0]*vB[91];
  JvB[91] = p[1]*x[1]*vB[91]*4.0+p[1]*vB[1]*x[91]*4.0-p[1]*x[1]*vB[92]*2.0-p[1]*vB[2]*x[91]*2.0;
  JvB[92] = p[2]*vB[92]-k[0]*p[2]*w[3]*vB[93];
  JvB[93] = p[3]*vB[93]-p[3]*vB[94]*2.0;
  JvB[94] = p[3]*vB[94]-p[3]*vB[95];
  JvB[95] = p[3]*vB[95]-p[3]*vB[96];
  JvB[96] = p[3]*vB[96]-p[3]*vB[97];
  JvB[97] = p[3]*vB[97]-p[3]*vB[98];
  JvB[98] = p[3]*vB[98]-k[1]*p[3]*w[2]*vB[90];
  JvB[99] = p[0]*w[0]*vB[99]-p[0]*w[0]*vB[100];
  JvB[100] = p[1]*x[1]*vB[100]*4.0+p[1]*vB[1]*x[100]*4.0-p[1]*x[1]*vB[101]*2.0-p[1]*vB[2]*x[100]*2.0;
  JvB[101] = p[2]*vB[101]-k[0]*p[2]*w[3]*vB[102];
  JvB[102] = p[3]*vB[102]-p[3]*vB[103]*2.0;
  JvB[103] = p[3]*vB[103]-p[3]*vB[104];
  JvB[104] = p[3]*vB[104]-p[3]*vB[105];
  JvB[105] = p[3]*vB[105]-p[3]*vB[106];
  JvB[106] = p[3]*vB[106]-p[3]*vB[107];
  JvB[107] = p[3]*vB[107]-k[1]*p[3]*w[2]*vB[99];
  JvB[108] = p[0]*w[0]*vB[108]-p[0]*w[0]*vB[109];
  JvB[109] = p[1]*x[1]*vB[109]*4.0+p[1]*vB[1]*x[109]*4.0-p[1]*x[1]*vB[110]*2.0-p[1]*vB[2]*x[109]*2.0;
  JvB[110] = p[2]*vB[110]-k[0]*p[2]*w[3]*vB[111];
  JvB[111] = p[3]*vB[111]-p[3]*vB[112]*2.0;
  JvB[112] = p[3]*vB[112]-p[3]*vB[113];
  JvB[113] = p[3]*vB[113]-p[3]*vB[114];
  JvB[114] = p[3]*vB[114]-p[3]*vB[115];
  JvB[115] = p[3]*vB[115]-p[3]*vB[116];
  JvB[116] = p[3]*vB[116]-k[1]*p[3]*w[2]*vB[108];
  JvB[117] = p[0]*w[0]*vB[117]-p[0]*w[0]*vB[118];
  JvB[118] = p[1]*x[1]*vB[118]*4.0+p[1]*vB[1]*x[118]*4.0-p[1]*x[1]*vB[119]*2.0-p[1]*vB[2]*x[118]*2.0;
  JvB[119] = p[2]*vB[119]-k[0]*p[2]*w[3]*vB[120];
  JvB[120] = p[3]*vB[120]-p[3]*vB[121]*2.0;
  JvB[121] = p[3]*vB[121]-p[3]*vB[122];
  JvB[122] = p[3]*vB[122]-p[3]*vB[123];
  JvB[123] = p[3]*vB[123]-p[3]*vB[124];
  JvB[124] = p[3]*vB[124]-p[3]*vB[125];
  JvB[125] = p[3]*vB[125]-k[1]*p[3]*w[2]*vB[117];
  JvB[126] = p[0]*w[0]*vB[126]-p[0]*w[0]*vB[127];
  JvB[127] = p[1]*x[1]*vB[127]*4.0+p[1]*vB[1]*x[127]*4.0-p[1]*x[1]*vB[128]*2.0-p[1]*vB[2]*x[127]*2.0;
  JvB[128] = p[2]*vB[128]-k[0]*p[2]*w[3]*vB[129];
  JvB[129] = p[3]*vB[129]-p[3]*vB[130]*2.0;
  JvB[130] = p[3]*vB[130]-p[3]*vB[131];
  JvB[131] = p[3]*vB[131]-p[3]*vB[132];
  JvB[132] = p[3]*vB[132]-p[3]*vB[133];
  JvB[133] = p[3]*vB[133]-p[3]*vB[134];
  JvB[134] = p[3]*vB[134]-k[1]*p[3]*w[2]*vB[126];
  JvB[135] = p[0]*w[0]*vB[135]-p[0]*w[0]*vB[136];
  JvB[136] = p[1]*x[1]*vB[136]*4.0+p[1]*vB[1]*x[136]*4.0-p[1]*x[1]*vB[137]*2.0-p[1]*vB[2]*x[136]*2.0;
  JvB[137] = p[2]*vB[137]-k[0]*p[2]*w[3]*vB[138];
  JvB[138] = p[3]*vB[138]-p[3]*vB[139]*2.0;
  JvB[139] = p[3]*vB[139]-p[3]*vB[140];
  JvB[140] = p[3]*vB[140]-p[3]*vB[141];
  JvB[141] = p[3]*vB[141]-p[3]*vB[142];
  JvB[142] = p[3]*vB[142]-p[3]*vB[143];
  JvB[143] = p[3]*vB[143]-k[1]*p[3]*w[2]*vB[135];
  JvB[144] = p[0]*w[0]*vB[144]-p[0]*w[0]*vB[145];
  JvB[145] = p[1]*x[1]*vB[145]*4.0+p[1]*vB[1]*x[145]*4.0-p[1]*x[1]*vB[146]*2.0-p[1]*vB[2]*x[145]*2.0;
  JvB[146] = p[2]*vB[146]-k[0]*p[2]*w[3]*vB[147];
  JvB[147] = p[3]*vB[147]-p[3]*vB[148]*2.0;
  JvB[148] = p[3]*vB[148]-p[3]*vB[149];
  JvB[149] = p[3]*vB[149]-p[3]*vB[150];
  JvB[150] = p[3]*vB[150]-p[3]*vB[151];
  JvB[151] = p[3]*vB[151]-p[3]*vB[152];
  JvB[152] = p[3]*vB[152]-k[1]*p[3]*w[2]*vB[144];
  JvB[153] = p[0]*w[0]*vB[153]-p[0]*w[0]*vB[154];
  JvB[154] = p[1]*x[1]*vB[154]*4.0+p[1]*vB[1]*x[154]*4.0-p[1]*x[1]*vB[155]*2.0-p[1]*vB[2]*x[154]*2.0;
  JvB[155] = p[2]*vB[155]-k[0]*p[2]*w[3]*vB[156];
  JvB[156] = p[3]*vB[156]-p[3]*vB[157]*2.0;
  JvB[157] = p[3]*vB[157]-p[3]*vB[158];
  JvB[158] = p[3]*vB[158]-p[3]*vB[159];
  JvB[159] = p[3]*vB[159]-p[3]*vB[160];
  JvB[160] = p[3]*vB[160]-p[3]*vB[161];
  JvB[161] = p[3]*vB[161]-k[1]*p[3]*w[2]*vB[153];
}

